/*
 * Copyright 2024 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 3 of the License, or (at your option) any later
 * version.
 *
 * This program is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with
 * this program. If not, see <https://www.gnu.org/licenses/>.
 */

#ifndef PYTHONUTIL_H
#define PYTHONUTIL_H

#include <Python.h>

#include <string>
#include <vector>
#include <map>

#define DATA_MANAGEMENT_PYTHON_PATH "/home/wangweinan/prj/ai-subsystem/ai-subsystem/ai-runtime/src/datamanagement/python/"

namespace pythonutil {

std::map<std::string, std::vector<int64_t>> convertPythonTokenDictToMap(PyObject* dictObject);
std::vector<std::string> convertPythonStringListToStd(PyObject* listObject);
std::string convertPythonStringToStd(PyObject* strObject);
int convertPythonIntToStd(PyObject* intObject);

}


#endif // PYTHONUTIL_H
